



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring SpEL表达式的理解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring SpEL表达式的理解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 16:17:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Spring的IOC本质就一个容器，也就是一个对象的工厂，我们通过配置文件注册我们的Bean对象，通过他进行对象的组装与床架。</p>
<p>SpEL表达式就是一种字符串编程,类似于JS里面的EVAL的作用，<strong>通过它可以运行字符串内容</strong></p>
<p><strong>特点：算是一种动态的编程在配置文件（xml配置文件或者注解表达式）--------------------------主流的编程都是基于GUI的开发模式（XML开发模式）里面的动态编程</strong></p>
<p><strong>重点：要是通过拼接字符串作为代码运行，SpEL就可以实现，一些灵活的功能</strong></p>
<div>
<pre class="prettyprint linenums">&lt;bean id="numberGuess" class="org.spring.samples.NumberGuess"&gt;<br />
  &lt;property name="randomNumber" value="#{ T(java.lang.Math).random() * 100.0 }"/&gt;<br />
  &lt;!-- other properties --&gt;<br />
&lt;/bean&gt;<br />
&lt;bean id="taxCalculator" class="org.spring.samples.TaxCalculator"&gt;<br />
  &lt;property name="defaultLocale" value="#{ systemProperties['user.region'] }"/&gt;<br />
  &lt;!-- other properties --&gt;<br />
&lt;/bean&gt;<br />
&lt;bean id="numberGuess" class="org.spring.samples.NumberGuess"&gt;<br />
  &lt;property name="randomNumber" value="#{ T(java.lang.Math).random() * 100.0 }"/&gt;<br />
  &lt;!-- other properties --&gt;<br />
&lt;/bean&gt;<br />
&lt;bean id="shapeGuess" class="org.spring.samples.ShapeGuess"&gt;<br />
  &lt;property name="initialShapeSeed" value="#{numberGuess.randomNumber }"/&gt;<br />
  &lt;!-- other properties --&gt;<br />
&lt;/bean&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">ExpressionParser parser = new SpelExpressionParser();<br />
Inventor tesla = new Inventor("Nikola Tesla", "Serbian");<br />
tesla.setPlaceOfBirth(new PlaceOfBirth("Smiljan"));<br />
StandardEvaluationContext context = new StandardEvaluationContext(tesla);<br />
String city = parser.parseExpression("PlaceOfBirth?.City").getValue(context, String.class);<br />
System.out.println(city); // Smiljan<br />
tesla.setPlaceOfBirth(null);<br />
city = parser.parseExpression("PlaceOfBirth?.City").getValue(context, String.class);<br />
System.out.println(city); // null - does not throw NullPointerException!!!</pre>
</div>
<p>否则：我们就只能通过JavaCompiler compiler = ToolProvider.getSystemJavaCompiler(); 来编译字符串生成类</p>
<div>
<pre class="prettyprint linenums">package com.test;<br />
import java.io.IOException;<br />
import java.lang.reflect.Method;<br />
import java.net.URI;<br />
import java.util.Arrays;<br />
import javax.tools.JavaCompiler;<br />
import javax.tools.JavaFileObject;<br />
import javax.tools.SimpleJavaFileObject;<br />
import javax.tools.StandardJavaFileManager;<br />
import javax.tools.ToolProvider;<br />
public class CompileString {<br />
    public static void main(String[] args) throws Exception {<br />
        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();<br />
        System.out.println(""+ToolProvider.getSystemJavaCompiler());<br />
        StandardJavaFileManager fileManager = compiler.getStandardFileManager(<br />
                null, null, null);<br />
        StringObject so = new StringObject(<br />
                "CalculatorTest",<br />
                "class CalculatorTest {"<br />
                        + " public int multiply(int multiplicand, int multiplier) {"<br />
                        + " System.out.println(multiplicand);"<br />
                        + " System.out.println(multiplier);"<br />
                        + " return multiplicand * multiplier;" + " }" + "}");<br />
        JavaFileObject file = so;<br />
        Iterable files = Arrays.asList(file);<br />
        JavaCompiler.CompilationTask task = compiler.getTask(null, fileManager,<br />
                null, null, null, files);<br />
        Boolean result = task.call();<br />
        System.out.println(result);<br />
        if (result) {<br />
            Class clazz = Class.forName("CalculatorTest");<br />
            Object instance = clazz.newInstance();<br />
            Method m = clazz.getMethod("multiply", new Class[] { int.class,<br />
                    int.class });<br />
            Object[] o = new Object[] { 3, 2 };<br />
            System.out.println(m.invoke(instance, o));<br />
        }<br />
    }<br />
}<br />
class StringObject extends SimpleJavaFileObject {<br />
    private String contents = null;<br />
    public StringObject(String className, String contents) throws Exception {<br />
        super(URI.create("string:///" + className.replace('.', '/')<br />
                + Kind.SOURCE.extension), Kind.SOURCE);<br />
        this.contents = contents;<br />
    }<br />
    public CharSequence getCharContent(boolean ignoreEncodingErrors)<br />
            throws IOException {<br />
        return contents;<br />
    }<br />
}<br />这种模式要使用java自定义的类加载器进行加载对应的类，对于类加载器可以参考网上的其他的文章....,通过这样可以实现动态的编程。<br /><strong>本质上，不管是java还是JS代码以及注解，最好的方式就是支持基于字符串的动态编程实现，目前都可以实现...............................</strong></pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gek087.html">使用python抓取婚恋网用户数据并用决策树生成自己择偶观</a>
		</li>
						<li><a href="https://www.batexi.com/a/390y5oo8.html">C语言乱谈（一） 20行代码生成BMP</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xrx08.html">一次有趣的XSS漏洞挖掘分析（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4okej8.html">Docker上运行dotnet core</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952lez9.html">Office 2013 激活工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd4wey8.html">sencha touch tabsidebar 源码扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zdp169.html">Js 替代</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1xwnj9.html">spring aop获取目标对象的方法对象（包括方法上的注解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkozpd8.html">java  对象比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kyyr69.html">SNS团队第七次站立会议（2017&period;04&period;28）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy171ngq.html">freemarker导出word文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m613j8.html">构建npm包出现&amp;quot&semi;找不到node&lowbar;modules&amp;quot&semi;的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zygz4d9.html">关于async 中return 和 return await 的差异</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5domdq.html">windows下的Redis主从集群搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ddyv9.html">实验二：MAL&mdash;&mdash;简单后门 by：赵文昊</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e431yz9.html">submit form to convert to a Java Bean model&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllpvjeq.html">Git-git push -u为何第二次不用指定-u？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o01jj8.html">Spring Cloud之踩坑01 -- Eureka高可用配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2wl5y9.html">SQL语法集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjng4l9.html">ApiGen 4&period;0配置项</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn1vvl28.html">用c&num;读取文件内容中文是乱码的解决方法：</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmjpp49.html">phonegap&lowbar;android配置文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdvlzz8.html">Hibernate3回顾-1-部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmlo519.html">css样式单位取整&comma;去掉&amp;&num;39&semi;px&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd54rd8.html">lucene之排序、设置权重、优化、分布式搜索&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv2zz1q.html">String、StringBuffer、StringBuilder之间的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmlnx19.html">网页颜色RGB记法和16进制记法转化方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdv0my8.html">datagridview 列位置 设置顺序与加载显示顺序不一致</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok15x19.html">js工具类 ----正则</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd56n78.html">room-views-用窗口颜色清除背景（Clear Background with Window Colour）选项</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
